! WHIZARD interface for Madgraph
! 
! Automatically generated file, do not edit
! 
      module ug_dtbb_const
      
        use kinds, only: D=>default  !NODEP!
      
        implicit none
        public
      
        integer,parameter :: ngraphs   =     4
        integer,parameter :: neigen    =     2
        integer,parameter :: nflows    =     2
        integer,parameter :: nexternal =     5
        real(D),parameter :: zero = 0.0_D
      
        real(D) :: gw, gwwa, gwwz                   ! /coup1/
        real(D), dimension(2) :: gal,gau,gad,gwf    ! /coup2a/
        real(D), dimension(2) :: gzn,gzl,gzu,gzd,g1 ! /coup2b/
        real(D) :: gwwh,gzzh,ghhh,gwwhh,gzzhh,ghhhh ! /coup3/
        complex(D), dimension(2,12) :: gchf         ! /coup4/
        real(D) :: wmass,wwidth,zmass,zwidth        ! /vmass1/
        real(D) :: amass,awidth,hmass,hwidth        ! /vmass2/
        real(D), dimension(12) :: fmass, fwidth     ! /fermions/
        real(D) :: gg(2), g                         ! /coupqcd/
      
        save
      
      end module ug_dtbb_const
      
      
! Driver module
! Process: : u g  -> d t b~
! 
! QCD order:     1
! QED order:     2
! 
      module ug_dtbb
      
        use kinds, only: D=>default !NODEP!
        use parameters
      
        use ug_dtbb_const !NODEP!
      
        implicit none
        private
      
        public :: scatter_diagonal_nonzero
        public :: number_particles, number_particles_in, number_particles_out
        public :: number_spin_states, number_spin_states_in, number_spin_states_out
        public :: spin_states, spin_states_in, spin_states_out
        public :: number_flavor_states, number_flavor_states_in, number_flavor_states_out
        public :: flavor_states, flavor_states_in, flavor_states_out
        public :: number_flavor_zeros, number_flavor_zeros_in, number_flavor_zeros_out
        public :: flavor_zeros, flavor_zeros_in, flavor_zeros_out
        public :: number_color_flows
        public :: color_flows, anticolor_flows
        public :: create, reset, destroy
      
!  
! Local Variables 
!  
          integer, parameter :: SAMPLE = 10, REPEAT = 5
          integer, parameter :: ncomb =   32
          integer, dimension(nexternal,ncomb)  :: nhel
          integer, dimension(nexternal,nflows) :: cflw
          integer, dimension(nexternal,nflows) :: aflw
!  
! Helicity combination tables
!  
          data nhel(1:5,  1) /  -1, -1, -1, -1, -1/
          data nhel(1:5,  2) /  -1, -1, -1, -1,  1/
          data nhel(1:5,  3) /  -1, -1, -1,  1, -1/
          data nhel(1:5,  4) /  -1, -1, -1,  1,  1/
          data nhel(1:5,  5) /  -1, -1,  1, -1, -1/
          data nhel(1:5,  6) /  -1, -1,  1, -1,  1/
          data nhel(1:5,  7) /  -1, -1,  1,  1, -1/
          data nhel(1:5,  8) /  -1, -1,  1,  1,  1/
          data nhel(1:5,  9) /  -1,  1, -1, -1, -1/
          data nhel(1:5, 10) /  -1,  1, -1, -1,  1/
          data nhel(1:5, 11) /  -1,  1, -1,  1, -1/
          data nhel(1:5, 12) /  -1,  1, -1,  1,  1/
          data nhel(1:5, 13) /  -1,  1,  1, -1, -1/
          data nhel(1:5, 14) /  -1,  1,  1, -1,  1/
          data nhel(1:5, 15) /  -1,  1,  1,  1, -1/
          data nhel(1:5, 16) /  -1,  1,  1,  1,  1/
          data nhel(1:5, 17) /   1, -1, -1, -1, -1/
          data nhel(1:5, 18) /   1, -1, -1, -1,  1/
          data nhel(1:5, 19) /   1, -1, -1,  1, -1/
          data nhel(1:5, 20) /   1, -1, -1,  1,  1/
          data nhel(1:5, 21) /   1, -1,  1, -1, -1/
          data nhel(1:5, 22) /   1, -1,  1, -1,  1/
          data nhel(1:5, 23) /   1, -1,  1,  1, -1/
          data nhel(1:5, 24) /   1, -1,  1,  1,  1/
          data nhel(1:5, 25) /   1,  1, -1, -1, -1/
          data nhel(1:5, 26) /   1,  1, -1, -1,  1/
          data nhel(1:5, 27) /   1,  1, -1,  1, -1/
          data nhel(1:5, 28) /   1,  1, -1,  1,  1/
          data nhel(1:5, 29) /   1,  1,  1, -1, -1/
          data nhel(1:5, 30) /   1,  1,  1, -1,  1/
          data nhel(1:5, 31) /   1,  1,  1,  1, -1/
          data nhel(1:5, 32) /   1,  1,  1,  1,  1/
!  
! Color flow tables
!  
          data cflw(1:5,  1) /   0,  1,  2,  5,  0/
          data cflw(1:5,  2) /   0,  5,  1,  2,  0/
      
          data aflw(1:5,  1) /   2,  3,  0,  0,  4/
          data aflw(1:5,  2) /   3,  4,  0,  0,  2/
      
      contains
      
        function number_particles () result (n)
          integer :: n
          n = 5
        end function number_particles
        function number_particles_in () result (n)
          integer :: n
          n = 2
        end function number_particles_in
        function number_particles_out () result (n)
          integer :: n
          n = 3
        end function number_particles_out
      
        function number_spin_states () result (n)
          integer :: n
          n =   32
        end function number_spin_states
        function number_spin_states_in () result (n)
          integer :: n
          n =    4
        end function number_spin_states_in
        function number_spin_states_out () result (n)
          integer :: n
          n =    8
        end function number_spin_states_out
      
        subroutine spin_states (a)
          integer, dimension(:,:), intent(inout) :: a
          a = nhel
        end subroutine spin_states
        subroutine spin_states_in (a)
          integer, dimension(:,:), intent(inout) :: a
          a = nhel(:number_particles_in(), ::number_spin_states_out())
        end subroutine spin_states_in
        subroutine spin_states_out (a)
          integer, dimension(:,:), intent(inout) :: a
          a = nhel(number_particles_in()+1:, :number_spin_states_out())
        end subroutine spin_states_out
      
        function number_flavor_states () result (n)
          integer :: n
          n = 1
        end function number_flavor_states
        subroutine flavor_states (a)
          integer, dimension(:,:), intent(inout) :: a
          a( 1,1) =        2
          a( 2,1) =       21
          a( 3,1) =        1
          a( 4,1) =        6
          a( 5,1) =       -5
        end subroutine flavor_states
      
        function number_flavor_states_in () result (n)
          integer :: n
          n = 1
        end function number_flavor_states_in
        subroutine flavor_states_in (a)
          integer, dimension(:,:), intent(inout) :: a
          a( 1,1) =        2
          a( 2,1) =       21
        end subroutine flavor_states_in
      
        function number_flavor_states_out () result (n)
          integer :: n
          n = 1
        end function number_flavor_states_out
        subroutine flavor_states_out (a)
          integer, dimension(:,:), intent(inout) :: a
          a( 1,1) =        1
          a( 2,1) =        6
          a( 3,1) =       -5
        end subroutine flavor_states_out
      
        function number_flavor_zeros () result (n)
          integer :: n
          n = 0
        end function number_flavor_zeros
        subroutine flavor_zeros (a)
          integer, dimension(:,:), intent(inout) :: a
          a = 0
        end subroutine flavor_zeros
      
        function number_flavor_zeros_in () result (n)
          integer :: n
          n = 0
        end function number_flavor_zeros_in
        subroutine flavor_zeros_in (a)
          integer, dimension(:,:), intent(inout) :: a
          a = 0
        end subroutine flavor_zeros_in
      
        function number_flavor_zeros_out () result (n)
          integer :: n
          n = 0
        end function number_flavor_zeros_out
        subroutine flavor_zeros_out (a)
          integer, dimension(:,:), intent(inout) :: a
          a = 0
        end subroutine flavor_zeros_out
      
        function number_color_flows () result (n)
          integer :: n
          n = 2
        end function number_color_flows
        subroutine color_flows (a)
          integer, dimension(:,:), intent(inout) :: a
          a = cflw
        end subroutine color_flows
        subroutine anticolor_flows (a)
          integer, dimension(:,:), intent(inout) :: a
          a = aflw
        end subroutine anticolor_flows
      
        subroutine multiplicity (m)
          integer, dimension(:), intent(inout) :: m
          m = 1
        end subroutine multiplicity
      
        subroutine create
        end subroutine create
      
        subroutine destroy
        end subroutine destroy
      
        subroutine reset (par)
          type(parameter_set), intent(in) :: par
          real(D) :: ez, ey, v
          ez = par%EE / par%SW / par%CW
          ey = par%EE * par%SW / par%CW
          gw     =  par%EE / par%SW
          gwwa   =  par%EE
          gwwz   =  par%EE * par%CW / par%SW
          gal    =  par%EE
          gau    = -par%EE * (2._D/3._D)
          gad    =  par%EE * (1._D/3._D)
          gwf(1) = -par%EE / par%SW / sqrt(2._D)
          gwf(2) =  0
          gzn(1) = -ez *  .5_D
          gzn(2) =  0
          gzl(1) = -ez *(-.5_D + par%SW**2)
          gzl(2) = -ey
          gzu(1) = -ez *( .5_D - (2._D/3._D)*par%SW**2)
          gzu(2) =  ey *            (2._D/3._D)
          gzd(1) = -ez *(-.5_D + (1._D/3._D)*par%SW**2)
          gzd(2) = -ey *            (1._D/3._D)
          g1     = 1
          v      = 2 * par%MW * par%SW / par%EE 
          gwwh   =  (par%EE/par%SW)**2 * v / 2
          gzzh   =  (par%EE/par%SW/par%CW)**2 * v / 2
          ghhh   = -(par%mH)**2 / v * 3
          gwwhh  =  (par%EE/par%SW)**2 / 2
          gzzhh  =  (par%EE/par%SW/par%CW)**2 / 2
          ghhhh  = -(par%mH/v)**2 * 3
          fmass( 1) = par%Me
          fmass( 2) = 0
          fmass( 3) = 0
          fmass( 4) = 0
          fmass( 5) = par%Mm
          fmass( 6) = 0
          fmass( 7) = par%Mc
          fmass( 8) = par%Ms
          fmass( 9) = par%Mt
          fmass(10) = 0
          fmass(11) = par%Mtop
          fmass(12) = par%Mb
          fwidth( 1) = 0
          fwidth( 2) = 0
          fwidth( 3) = 0
          fwidth( 4) = 0
          fwidth( 5) = 0
          fwidth( 6) = 0
          fwidth( 7) = 0
          fwidth( 8) = 0
          fwidth( 9) = 0
          fwidth(10) = 0
          fwidth(11) = par%wtop
          fwidth(12) = 0
          gchf(1,:)  = (-ez / par%mZ / 2) * fmass
          gchf(2,:) = gchf(1,:)
          gg = -1
          wmass = par%mW
          zmass = par%mZ
          amass = 0
          hmass = par%mH
          wwidth = par%wW
          zwidth = par%wZ
          awidth = 0
          hwidth = par%wH
        end subroutine reset
      
        subroutine scatter_diagonal_nonzero (p, rho_in, rho_out, zero, n)
          real(D), dimension(0:,:), intent(in) :: p
          real(D), dimension(:,:), intent(in) :: rho_in
          real(D), dimension(:,:), intent(inout) :: rho_out
          integer, dimension(:,:,:,:), intent(inout) :: zero
          integer, intent(in) :: n
          integer :: hi, ho, h
          real(D) :: sqme
          h = 0
          rho_out = 0
          do hi=1, number_spin_states_in ()
             do ho=1, number_spin_states_out ()
                h = h + 1
                if (n <= SAMPLE .and. zero(hi,1,ho,1) <= REPEAT) then
                  sqme = sqme_pol (p, nhel(:,h))
                  if (sqme <= tiny (1._D)) zero(hi,1,ho,1) = zero(hi,1,ho,1) + 1
                else if (zero(hi,1,ho,1) < REPEAT) then
                  sqme = sqme_pol (p, nhel(:,h))
                else
                  sqme = 0
                end if
                rho_out (ho,1) = rho_out (ho,1) + sqme * rho_in (hi,1)
             end do
          end do
        end subroutine scatter_diagonal_nonzero
      
      
! 
! Function generated by MADGRAPH [modified *FP,WK*]
! Returns amplitude squared summed/avg over colors
! for the point in phase space p1,p2,p3,p4,...
! and helicity nhel(1),nhel(2),....
! Optionally, probabilities for color flows are returned.
!  
! For process : u g  -> d t b~  
!  
          function sqme_pol (pp,nhel,pcol)
!  
! Arguments 
!  
          real(D) :: sqme_pol
          real(D),dimension(0:3,nexternal),intent(in) :: pp
          integer,dimension(nexternal),    intent(in) :: nhel
          real(D),dimension(nexternal),    intent(out), optional :: pcol
!  
! Local Variables 
!  
          real(D) :: s
      
          complex(D), dimension(2,12) :: gh          
!  
          real(D), dimension(0:3) :: p1,p2,p3,p4,p5! 
          integer                           :: i
          real(D),dimension(neigen)         :: eigen_val
          real(D),dimension(ngraphs,neigen) :: eigen_vec
          real(D),dimension(ngraphs,nflows) :: flow_coeff
          complex(D)                        :: ztemp
          complex(D),dimension(ngraphs)     :: amp
          complex(D),dimension(6) :: w1  , w2  , w3  , w4  , w5       
          complex(D),dimension(6) :: w6  , w7  , w8  , w9  , w10      
          complex(D),dimension(6) :: w11 , w12 
!  
! Color Data
!  
          data eigen_val(1  )/       1.0000000000000002e+00_D/
          data eigen_vec(1   ,1  )/ -7.0710678118654746e-01_D/
          data eigen_vec(2   ,1  )/  0.0000000000000000e+00_D/
          data eigen_vec(3   ,1  )/  0.0000000000000000e+00_D/
          data eigen_vec(4   ,1  )/ -7.0710678118654746e-01_D/
          data eigen_val(2  )/       1.0000000000000002e+00_D/
          data eigen_vec(1   ,2  )/  0.0000000000000000e+00_D/
          data eigen_vec(2   ,2  )/ -7.0710678118654746e-01_D/
          data eigen_vec(3   ,2  )/ -7.0710678118654746e-01_D/
          data eigen_vec(4   ,2  )/  0.0000000000000000e+00_D/
         data flow_coeff(1   ,1  )/  1.0000000000000000e+00_D/
         data flow_coeff(2   ,1  )/  0.0000000000000000e+00_D/
         data flow_coeff(3   ,1  )/  0.0000000000000000e+00_D/
         data flow_coeff(4   ,1  )/  1.0000000000000000e+00_D/
         data flow_coeff(1   ,2  )/  0.0000000000000000e+00_D/
         data flow_coeff(2   ,2  )/  1.0000000000000000e+00_D/
         data flow_coeff(3   ,2  )/  1.0000000000000000e+00_D/
         data flow_coeff(4   ,2  )/  0.0000000000000000e+00_D/
! ----------
! Begin Code
! ----------
          p1 = pp(:,1)
          p2 = pp(:,2)
          p3 = pp(:,3)
          p4 = pp(:,4)
          p5 = pp(:,5)
      
          gh     = gchf
      
          call ixxxxx(p1  ,fmass(3  ),nhel(1  ), 1,w1  )
          call vxxxxx(p2  , zero,nhel(2  ),-1,w2  )
          call oxxxxx(p3  ,fmass(4  ),nhel(3  ), 1,w3  )
          call oxxxxx(p4  ,fmass(11 ),nhel(4  ), 1,w4  )
          call ixxxxx(p5  ,fmass(12 ),nhel(5  ),-1,w5  )
          call fvoxxx(w3  ,w2  ,gg,fmass(4  ),fwidth(4  ),w6  )
          call jioxxx(w1  ,w6  ,gwf,wmass,wwidth,w7  )
          call iovxxx(w5  ,w4  ,w7  ,gwf,amp(1   ))
          call jioxxx(w1  ,w3  ,gwf,wmass,wwidth,w8  )
          call fvoxxx(w4  ,w8  ,gwf,fmass(12 ),fwidth(12 ),w9  )
          call iovxxx(w5  ,w9  ,w2  ,gg,amp(2   ))
          call fvoxxx(w4  ,w2  ,gg,fmass(11 ),fwidth(11 ),w10 )
          call iovxxx(w5  ,w10 ,w8  ,gwf,amp(3   ))
          call fvixxx(w1  ,w2  ,gg,fmass(3  ),fwidth(3  ),w11 )
          call jioxxx(w11 ,w3  ,gwf,wmass,wwidth,w12 )
          call iovxxx(w5  ,w4  ,w12 ,gwf,amp(4   ))
          if (present(pcol)) then
             do i = 1, nflows
                 ztemp = sum(flow_coeff(:,i)*amp(:))
                 pcol(i) = ztemp * conj(ztemp)
             end do
             if (any(pcol/=0))  pcol = pcol / sum(pcol)
          end if
          s = 0.0_D
          do i = 1, neigen
              ztemp = sum(eigen_vec(:,i)*amp(:))
              s = s + ztemp*eigen_val(i)*conjg(ztemp)
          enddo
!          call gaugecheck(amp,ztemp,eigen_vec,eigen_val,ngraphs,neigen)
          sqme_pol = s
        end function sqme_pol
      
      end module ug_dtbb
